/*Written by : Debasish Das*/
/*Jan 6 2005*/

#include <stdio.h>
#include <stdlib.h>
#include "route_automata.h"

/*Union declaration*/



/*Function declarations*/
void state_clb();
void state_up();
void state_down();
void state_left();
void state_right();
void automata_controller(FILE* fpt);
int readline(FILE* fpt);

int main(int argc,char** argv)
{
  FILE* fpt;
  if(argc != 2)
    {
      printf("The correct syntax of the commandline is following\n");
      printf("Give the name of the file containing routing information\n");
      printf("after the program name\n");
      exit(1);
    }
  else
    {
      fpt = fopen(argv[1],"r");
      if(fpt==NULL)
	{
	  printf("The routed file doesn't exists\n");
	  exit(1);
	}
      else
	{
	  /* The routing file is successfully opened */
	  automata_controller(fpt);
	}
      printf("Please refer the dump files for analysis results\n");
    }
}

void automata_controller(FILE* fpt)
{
  int i,check;
  char c='y';
  char buffer[80];

  while(1)
    {
      i=readline(fpt,buffer);
      if(i==NET)
	{
	  /* The automata construct */
	  i=readline(fpt,buffer);
	  if(i==SOURCE)
	    state_clb(fpt,buffer);
	  else
	    {
	      printf("Incorrect file format\n");
	      exit(1);
	    }
	  
	  /* Dumping the automata */
	  printf("Do you want to dump the automata(y/n):");
	  scanf("%c",&c);
	  if(c=='y')
	    dump_automata();
	}
      if(i==EOF)
	break;
    }
}

void state_clb(FILE* fpt,char* buffer)
{
  int i;
  /* copy buffer and do the processing */
  do
    {
      i=readline(fpt,buffer);
      /* Copy buffer and continue processing */
    }while(i != CHANX ||i != CHANY || i!=NET);
  /* CLB to CLB transition is not possible */
  
  /* Code to be executed in this state */

  switch(i)
    {
    case CHANX:
      check = find_direction(buffer);
      if(check)
	state_left(fpt,buffer);
      else
	state_right(fpt,buffer);
      break;
    case CHANY:
      check = find_direction(buffer);
      if(check)
	state_up(fpt,buffer);
      else
	state_down(fpt,buffer);
      break;
    case NET:
      break;
    }      
}

void state_left(FILE* fpt,
