#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define CHILD 1
#define SIBLING 2

/* Defining the tree structure */

struct route_net
{
  int inode;
  struct route_net* parent;
  struct route_net* child;
  struct route_net* sibling;
};

typedef struct route_net* proute_net;

/* function prototypes */
void controller(int inet);
proute_net insert(proute_net head, int inode, int option);
proute_net traceback(proute_net head, int inode);
void process(proute_net head);
void save(proute_net* list, proute_net head,int netid);

/* function definitions */

/* Option says whether to insert it as a child or sibling */
proute_net insert(proute_net head, int inode, int option)
{
  proute_net node;
  /*allocating memory to the node*/
  node = (proute_net)malloc(sizeof(struct route_net));
  node->parent = head;
  node->child = NULL;
  node->sibling = NULL;
  
  switch(option)
    {
    case CHILD:
      node->inode = inode;
      head->child = node;
      break;
    case SIBLING:
      node->inode = inode;
      head->sibling = node;
      break;
    }
  return(node);
}

/*Traceback function goes to the insert point and return the pointer*/
proute_net traceback(proute_net head,int inode)
{
  while(head->inode!=inode)
    head = head->parent;
  return(head);
}
  
/*Process takes the head of the net and prints the tree*/
/*Simple DFS implementation to give all source->sink connections*/
void process(proute_net head)
{
  if(head->child!=NULL)
    {
      printf("Inode : %d",head->inode);
      head = head->child;
      process(head);
    }
  if(head->sibling!=NULL)
    {
      printf("\nSibling Inode : %d",head->inode);
      head = head->sibling;
      process(head);
    }
  return;
}

/*This function saves the tree corresponding to a given netid*/
void save(proute_net* list, proute_net head,int netid)
{
  list[netid]=head;
  return;
}

/*Controller function for this module*/
void controller(int inet)
{
  int inode,newinode,ipin, bnum, ilow, jlow, blk_pin, iclass,firstsink = 0;
  t_rr_type rr_type;
  struct s_trace *tptr;
  char *name_type[] = {"SOURCE", "SINK", "IPIN", "OPIN", "CHANX","CHANY"};
  proute_net head=NULL,temp=NULL;
  
  tptr = trace_head[inet]; 
  /* Allocating memory to head */
  head = (proute_net)malloc(sizeof(struct route_net));
  head->parent = NULL;
  head->child = NULL;
  head->sibling = NULL;
  
  /*making temp the modifiable head*/
  temp = head;
  
  while (tptr != NULL) 
    {
      inode = tptr->index;
      
      rr_type = rr_node[inode].type;
      ilow = rr_node[inode].xlow;
      jlow = rr_node[inode].ylow;
      if ((ilow != rr_node[inode].xhigh) || (jlow != rr_node[inode].yhigh)) 
	{
	  //Processing for this particular case
	}
      
      /*Insert the inode into the route_tree*/
      temp = insert(temp,inode,CHILD);
      if( rr_type == SINK )
	{
	  tptr = tptr->next;
	  newinode = tptr->inode;
	  /*Send it for traceback*/
	  temp = traceback(temp,inode);
	  insert(temp,inode,SIBLING);
	}
      tptr = tptr->next;
    }
  
  /*Calling the process function*/
  process(head);
}
